/********************************************************************
 Software License Agreement:

 The software supplied herewith by Microchip Technology Incorporated
 (the "Company") for its PIC(R) Microcontroller is intended and
 supplied to you, the Company's customer, for use solely and
 exclusively on Microchip PIC Microcontroller products. The
 software is owned by the Company and/or its supplier, and is
 protected under applicable copyright laws. All rights are reserved.
 Any use in violation of the foregoing restrictions may subject the
 user to criminal sanctions under applicable laws, as well as to
 civil liability for the breach of the terms and conditions of this
 license.

 THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
 WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *******************************************************************/

/** INCLUDES *******************************************************/
#include "system.h"

#include <stdint.h>
#include <string.h>
#include <stddef.h>

#include "usb.h"

//#include <app_led_usb_status.h>
#include "app_device_cdc_basic.h"
#include "usb_config.h"

#include <stdlib.h>
#include <stdio.h>
//#include <string.h>

/** VARIABLES ******************************************************/

//static bool buttonPressed;
static char buttonMessage[] = "Button pressed.\r\n";
static uint8_t readBuffer[CDC_DATA_OUT_EP_SIZE];//=64
//static uint8_t writeBuffer[CDC_DATA_IN_EP_SIZE];//=64
static uint8_t writeBuffer[640];

//***変更1
#define _XTAL_FREQ  48000000             //__delay_ms

void SetPWM(unsigned char N);
unsigned short ADC0();
unsigned short ADC1();
unsigned char V_T2CKPS0[13]={1,1,1,1,1,1,1,1,1,1,0,0,0};
unsigned char V_T2CKPS1[13]={1,1,1,1,1,1,1,1,0,0,0,0,0};
unsigned char V_PR2[13]={255,127,63,31,15,7,3,1,3,1,3,1,0};
unsigned char V_DC1B1[13]={0,0,0,0,0,0,0,0,0,0,0,0,1};
unsigned char V_CCPR1L[13]={128,64,32,16,8,4,2,1,2,1,2,1,0};
/*********************************************************************
* Function: void APP_DeviceCDCBasicDemoInitialize(void);
*
* Overview: Initializes the demo code
*
* PreCondition: None
*
* Input: None
*
* Output: None
*
********************************************************************/
void APP_DeviceCDCBasicDemoInitialize()
{
    CDCInitEP();

    
    line_coding.bCharFormat = 0;
    line_coding.bDataBits = 8;
    line_coding.bParityType = 0;
    line_coding.dwDTERate = 9600;

    //buttonPressed = false;

    
}

/*********************************************************************
* Function: void APP_DeviceCDCBasicDemoTasks(void);
*
* Overview: Keeps the demo running.
*
* PreCondition: The demo should have been initialized and started via
*   the APP_DeviceCDCBasicDemoInitialize() and APP_DeviceCDCBasicDemoStart() demos
*   respectively.
*
* Input: None
*
* Output: None
*
********************************************************************/
void APP_DeviceCDCBasicDemoTasks()
{

    /*if(BUTTON_IsPressed(BUTTON_DEVICE_CDC_BASIC_DEMO) == true)
    {

        if(buttonPressed == false)
        {

            if(mUSBUSARTIsTxTrfReady() == true)
            {
                putrsUSBUSART(buttonMessage);
                buttonPressed = true;
            }
        }
    }
    else
    {

        buttonPressed = false;
    }*/

    /* Check to see if there is a transmission in progress, if there isn't, then
     * we can see about performing an echo response to data received.
     */
    if( USBUSARTIsTxTrfReady() == true)
    {
        uint8_t i;
        uint8_t numBytesRead;

        numBytesRead = getsUSBUSART(readBuffer, sizeof(readBuffer));

        /* For every byte that was read... */
        for(i=0; i<numBytesRead; i++)
        {
            switch(readBuffer[i])
            {
                /* If we receive new line or line feed commands, just echo
                 * them direct.
                 */
                case 0x0A:
                case 0x0D:
                    writeBuffer[i] = readBuffer[i];
                    break;

                /* If we receive something else, then echo it plus one
                 * so that if we receive 'a', we echo 'b' so that the
                 * user knows that it isn't the echo enabled on their
                 * terminal program.
                 */
                default:
                    writeBuffer[i] = readBuffer[i] + 1;
                    break;
            }
        }

        if(numBytesRead > 0)
        {
            /* After processing all of the received data, we need to send out
             * the "echo" data now.
             */
            putUSBUSART(writeBuffer,numBytesRead);
        }
    }

    CDCTxService();
}

void MyCDCBasicTasks()
{
    int i2;
    if( USBUSARTIsTxTrfReady() == true)
    {
        uint8_t i,j,k;
        uint8_t numBytesRead;
        unsigned char FIN[5][20];
        unsigned char N;
        unsigned char MywriteBuffer[64];

        //for(i=0;i<640;i++){writeBuffer[i]=0;}

        numBytesRead = getsUSBUSART(readBuffer, sizeof(readBuffer));

        if(numBytesRead > 0)
        {
            j=0;k=0;
            for(i=0;i<numBytesRead;i++)
            {
                if(readBuffer[i] == '#')
                {
                    FIN[j][k]=0;
                    j++;
                    if(j>5){j=4;}
                    k=0;
                }
                else
                {
                    FIN[j][k]=readBuffer[i];
                    k++;if(k>20){k=19;}
                }
            }
            unsigned short TEST=1;
            if(FIN[0][0]=='A' && FIN[0][1]=='A' && FIN[0][2]==0)
            {
                N=atoi((const char *)FIN[1]);

                sprintf(writeBuffer,"");
                SetPWM(0);TEST=ADC0();TEST=ADC1();//PMWとADCの捨て打ち、安定化おまじない
                for(i2=0;i2<13;i2++)
                {
                    SetPWM(i2);//PWM実行
                    __delay_ms( 5 );//PWM安定化待ち
                    sprintf(MywriteBuffer,"%d\t%d\t%d\r\n",i2,ADC0(),ADC1());//ADC実行
                    strcat(writeBuffer,MywriteBuffer);//文字連結
                }
                numBytesRead = strlen(writeBuffer);
                putUSBUSART(writeBuffer,numBytesRead);
                SetPWM(N);//指定の周波数にPWMを設定、デバッグ用
                TEST=2;
            }
        }
    }
    CDCTxService();
}

void SetPWM(unsigned char N)
{
    T2CONbits.TMR2ON=0;// タイマ2停止
    PR2 =  V_PR2[N];//周期を設定（設定 + 1）＝1/（48MHｚ*（設定+1））
    CCP1CONbits.DC1B1=V_DC1B1[N];//H時間の1/2の単位設定
    CCP1CONbits.DC1B0=0;//H時間の1/4の単位設定
    CCPR1L =V_CCPR1L[N];//Hの時間設定=1/(48MHz*設定）
    T2CONbits.T2CKPS1=V_T2CKPS1[N];//タイマ2プリスケーラ値設定
    T2CONbits.T2CKPS0=V_T2CKPS0[N];//タイマ2プリスケーラ値設定
    TMR2 = 0;// TMR2レジスタをクリア
    T2CONbits.TMR2ON=1;
    // タイマ2起動
}

unsigned short ADC0()
{
    unsigned short result;
    
    ADCON0bits.GO = 0;              // Stop AD conversion
    __delay_ms( 1 );
    ADCON0bits.CHS = 0b0000; //Analog Channel Select bits=Channel 0 (AN0)
    __delay_ms( 2 );
    ADCON0bits.GO = 1;              // Start AD conversion
    while(ADCON0bits.NOT_DONE);     // Wait for conversion
    result=ADRESH*256+ADRESL;
    return result;
}

unsigned short ADC1()
{
    unsigned short result;

    ADCON0bits.GO = 0;              // Stop AD conversion
    __delay_ms( 1 );
    ADCON0bits.CHS = 0b0001; //Analog Channel Select bits=Channel 0 (AN0)
    __delay_ms( 2 );
    ADCON0bits.GO = 1;              // Start AD conversion
    while(ADCON0bits.NOT_DONE);     // Wait for conversion
    result=ADRESH*256+ADRESL;
    return result;
}